import json
from pprint import pprint as pp
from bs4 import BeautifulSoup as bs
import requests, os, sys


def raiseException(err):
    print(err)
    exc_type, exc_obj, exc_tb = sys.exc_info()
    file_name = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]
    print(exc_type, file_name, exc_tb.tb_lineno)


cookies = {}
headers = {
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8',
    'Accept-Language': 'en-GB,en;q=0.8',
    'Cache-Control': 'no-cache',
    'Connection': 'keep-alive',
    'Pragma': 'no-cache',
    'Referer': 'https://www.floraxchange.nl/Aanbod',
    'Sec-Fetch-Dest': 'document',
    'Sec-Fetch-Mode': 'navigate',
    'Sec-Fetch-Site': 'same-origin',
    'Sec-GPC': '1',
    'Upgrade-Insecure-Requests': '1',
    'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36',
}


def getCookie(username='438-18780', password='6582688@Jsc'):
    print('\nGetting new cookies.')
    global cookies

    header = {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8',
        'Accept-Language': 'en-GB,en;q=0.8',
        'Cache-Control': 'no-cache',
        'Connection': 'keep-alive',
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36',
    }

    session = requests.Session()
    session.get('https://www.floraxchange.nl', headers=header)
    # setupCookie = response.cookies.get_dict()
    setupCookie = session.cookies.get_dict()
    data = {
        'txtGebruikersnaam': username,
        'txtWachtwoord': password,
        'chkIngelogdBlijven': [
            'true',
            'false',
        ],
        'txtReturn': '',
    }
    header = {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8',
        'Accept-Language': 'en-GB,en;q=0.8',
        'Cache-Control': 'no-cache',
        'Connection': 'keep-alive',
        'Origin': 'https://www.floraxchange.nl',
        'Pragma': 'no-cache',
        'Referer': 'https://www.floraxchange.nl/',
        'Sec-Fetch-Dest': 'document',
        'Sec-Fetch-Mode': 'navigate',
        'Sec-Fetch-Site': 'same-origin',
        'Sec-Fetch-User': '?1',
        'Sec-GPC': '1',
        'Upgrade-Insecure-Requests': '1',
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36',
    }

    session.post('https://www.floraxchange.nl/Account/InloggenFx', cookies=setupCookie, headers=header, data=data)
    header = {
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8',
        'Accept-Language': 'en-GB,en;q=0.6',
        'Cache-Control': 'no-cache',
        'Connection': 'keep-alive',
        'Pragma': 'no-cache',
        'Referer': 'https://www.floraxchange.nl/Aanbod',
        'Sec-Fetch-Dest': 'document',
        'Sec-Fetch-Mode': 'navigate',
        'Sec-Fetch-Site': 'same-origin',
        'Sec-Fetch-User': '?1',
        'Sec-GPC': '1',
        'Upgrade-Insecure-Requests': '1',
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36',
    }
    requests.get('https://www.floraxchange.nl/Aanbod/ToggleToepassingFilter/2', cookies=session.cookies.get_dict(), headers=header)
    cookies = session.cookies.get_dict()
    print('Got Cookies')


def getSoup(url: str):
    response = requests.get(url, cookies=cookies, headers=headers)
    soup = bs(response.text, 'lxml')
    return soup


def setPageSize(size: int):
    params = {
        'aantal': size,
    }
    requests.get('https://www.floraxchange.nl/Aanbod/ZetAantalPerPagina', params=params, cookies=cookies, headers=headers)


def formData(name, seller, grower, pot_size, height, maturity, color, cultivation, cuttings, plant_shape, thikness, tendril_length, moq, price):
    return {
        'Product Name': name,
        'Seller Info': seller,
        'Grower': grower,
        'Pot size': pot_size,
        'Minimum plant height including pot': height,
        'Maturity stage': maturity,
        'Color': color,
        'Cultivation method': cultivation,
        'Min number of cuttings/plants per pot': cuttings,
        'Plant shape': plant_shape,
        'Thickness': thikness,
        'Minimum tendril length': tendril_length,
        'MOQ': moq,
        'Price': price
    }


def main():
    getCookie()
    print('\nSetting page size to "1000".\n')
    setPageSize(1000)
    soup = getSoup('https://www.floraxchange.nl/Aanbod')
    pagination = soup.select_one('ul.pagination')
    numOfPages = int(pagination.select('li')[-2].text)
    print(f'Total {numOfPages} pages.\n')
    allProducts = []
    for page_no in range(1, numOfPages+1):
        print("#####################################")
        print(f'Running page {page_no} of {numOfPages}.')
        print("#####################################")
        soup = getSoup(f'https://www.floraxchange.nl/Aanbod?page={page_no}')
        container = soup.select_one('div.cnr_aanbodRegels')
        allList = container.select('div.cnr_aanbod')
        print(f'Total {len(allList)} products in page {page_no}.\n')

        for prod in allList:
            nameElm = prod.select_one('h2.panel-title')
            name = nameElm.select_one('a').text
            sellerInfo = nameElm.select_one('small').text
            infoElm = prod.select_one('.panel-body')
            grower = infoElm.select_one('h4 a').text
            attrElm = infoElm.select('table')[-1]

            trs = attrElm.select('tr')
            pot_size = height = maturity = color = cultivation = cuttings = plant_shape = thikness = tendril_length = 'X'
            for tr in trs:
                row = tr.select('td')
                key = row[0].text
                value = row[1].text
                if key == 'Pot size':
                    pot_size = value
                elif key == 'Minimum plant height including pot':
                    height = value
                elif key == 'Maturity stage':
                    maturity = value
                elif key.lower().find('color') != -1:
                    color = value
                elif key == 'Cultivation method':
                    cultivation = value
                elif key == 'Min number of cuttings/plants per pot':
                    cuttings = value
                elif key == 'Plant shape':
                    plant_shape = value
                elif key == 'Thickness':
                    thikness = value
                elif key == 'Minimum tendril length':
                    tendril_length = value

            moqElm = infoElm.select_one('div.col-sm-2.hidden-xs')
            moq = []
            if moqElm.select_one('ul.list-unstyled') is not None:
                moqElm = moqElm.select_one('ul.list-unstyled')
                for li in moqElm.select('li'):
                    moq.append(li.text)
            else:
                moq.append(moqElm.text)

            priceElm = infoElm.select_one('div.prijs')
            price = 'X'
            if priceElm is not None:
                price = list(priceElm.children)[0].text

            singleProd = formData(name, sellerInfo, grower, pot_size, height, maturity, color, cultivation, cuttings, plant_shape, thikness, tendril_length, moq, price)
            pp(singleProd, sort_dicts=False)
            allProducts.append(singleProd)
        json.dump(allProducts, open('products.json', 'w', encoding='utf-8'), indent=4)


if __name__ == '__main__':
    main()
    print('Done')
